 
/*------------------------------------------------------------------------
   File        : DemoHandler
   Purpose     : 
   Syntax      : 
   Description : 
   Author(s)   : egarcia
   Created     : Thu Oct 22 12:42:24 EDT 2015
   Notes       : 
 ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING OpenEdge.Web.WebHandler.
USING OpenEdge.Web.WebResponse FROM PROPATH.
USING OpenEdge.Web.WebResponseWriter FROM PROPATH.
USING Progress.Json.ObjectModel.JsonObject FROM PROPATH.
USING OpenEdge.Net.HTTP.StatusCodeEnum FROM PROPATH.


CLASS DemoHandler INHERITS WebHandler: 

    DEFINE TEMP-TABLE ttCustomer LIKE Customer.
		
    METHOD OVERRIDE PROTECTED INTEGER HandleNotAllowedMethod( INPUT poRequest AS OpenEdge.Web.IWebRequest ):
		
        UNDO, THROW NEW Progress.Lang.AppError("METHOD NOT IMPLEMENTED").
    END METHOD.

    METHOD OVERRIDE PROTECTED INTEGER HandleNotImplemented( INPUT poRequest AS OpenEdge.Web.IWebRequest ):
		
        UNDO, THROW NEW Progress.Lang.AppError("METHOD NOT IMPLEMENTED").
    END METHOD.
 	
	
    /*------------------------------------------------------------------------------
            Purpose:                                                                
            Notes:                                                                        
    ------------------------------------------------------------------------------*/
    METHOD OVERRIDE PROTECTED INTEGER HandleGet( INPUT poRequest AS OpenEdge.Web.IWebRequest ):
 		
        DEFINE VARIABLE response   AS OpenEdge.Web.WebResponse       NO-UNDO.
        DEFINE VARIABLE writer     AS OpenEdge.Web.WebResponseWriter NO-UNDO.
        
        DEFINE VARIABLE jsonObject AS JsonObject                     NO-UNDO.
        
        response = NEW WebResponse().       
        writer = NEW WebResponseWriter(response).
        
        // writer:Write("Hello World!!!").
        
        FOR EACH Customer:
            CREATE ttCustomer.
            BUFFER-COPY Customer TO ttCustomer.
        END.
        
        jsonObject = NEW JsonObject().
        jsonObject:READ(TEMP-TABLE ttCustomer:HANDLE).
        
        response:StatusCode = 200.
        response:ContentType = "application/json".  
       
        writer:Write(jsonObject:GetJsonText()).
        
        writer:Flush().
        writer:Close().

        RETURN 0.
    END METHOD. 
	
END CLASS.