/*------------------------------------------------------------------------
   File        : GenericService
   Purpose     : 
   Syntax      : 
   Description : 
   Author(s)   : egarcia
   Created     : Mon Aug 31 11:21:00 EST 2015
   Notes       : 
 ----------------------------------------------------------------------*/

USING Progress.Json.ObjectModel.*.
USING Progress.Lang.*.
USING OpenEdge.Net.*.
USING OpenEdge.Net.HTTP.*.
USING OpenEdge.Web.*.


BLOCK-LEVEL ON ERROR UNDO, THROW.

CLASS GenericService inherits WebHandler: 

    METHOD OVERRIDE PROTECTED INTEGER HandleGet(INPUT poRequest AS OpenEdge.Web.IWebRequest):
        DEFINE VARIABLE response    AS WebResponse       NO-UNDO.
        DEFINE VARIABLE writer      AS WebResponseWriter NO-UNDO.
        DEFINE VARIABLE body        AS LONGCHAR          NO-UNDO.
        
        DEFINE VARIABLE accessType  AS CHARACTER         NO-UNDO.
        DEFINE VARIABLE tableName   AS CHARACTER         NO-UNDO.
        DEFINE VARIABLE queryString AS CHARACTER         NO-UNDO.        
        DEFINE VARIABLE filter      AS CHARACTER         NO-UNDO.
        
        DEFINE VARIABLE entity      AS GenericEntity     NO-UNDO.
        
        DEFINE VARIABLE dynClass    AS IBusinessEntity   NO-UNDO.
        DEFINE VARIABLE hDataSet    AS HANDLE            NO-UNDO.
        
        DEFINE VARIABLE jsonObject  AS JsonObject        NO-UNDO.       
        
        DEFINE VARIABLE hCP         AS HANDLE            NO-UNDO.

        accessType  = poRequest:GetPathParameter("AccessType").
        tableName   = poRequest:GetPathParameter("TableName").
        
        MESSAGE "DEBUG: " accessType tableName.
        
        queryString = poRequest:GetContextValue("QUERY_STRING").
        IF queryString > "" THEN 
        DO:
            DEFINE VARIABLE cParam AS CHARACTER NO-UNDO.
            DEFINE VARIABLE i      AS INTEGER   NO-UNDO.
            DEFINE VARIABLe cName  AS CHARACTER NO-UNDO.
            DEFINE VARIABLE idx    AS INTEGER   NO-UNDO.
            
            DO i = 1 TO NUM-ENTRIES(queryString, "&"):
                cParam = ENTRY(i, queryString, "&").
                idx = INDEX(cParam, "=").
                IF idx > 0 THEN 
                DO:
                    cName = SUBSTRING(cParam, 1, idx - 1).
                    MESSAGE "DEBUG: cParam: " cParam cName.
                    IF cName = "filter" THEN 
                    DO:
                        filter = SUBSTRING(cParam, INDEX(queryString, "=") + 1).
                        IF filter > "" THEN 
                        DO:
                            filter = OpenEdge.Net.URI:Decode(filter).
                        END.
                        MESSAGE "DEBUG: filter: " filter.
                    END.
                END.
            END.
        END.

        /*        
                MESSAGE "DEBUG: REMOTE_USER: " poRequest:GetContextValue("REMOTE_USER").
                hCP = SESSION:CURRENT-REQUEST-INFO:GetClientPrincipal() NO-ERROR.
                IF hCP <> ? THEN 
                DO:
                    MESSAGE "DEBUG: SESSION: USERID: ROLES: " hCP:USER-ID hCP:ROLES.
                END.
                MESSAGE "DEBUG: queryString: " queryString.
                MESSAGE "DEBUG: filter: " filter.
        */
        
        entity = NEW GenericEntity(tableName).
        IF accessType = "data" THEN 
        DO:

            dynClass = DYNAMIC-NEW tableName () NO-ERROR.                
            MESSAGE "DEBUG: dynClass: " dynClass ERROR-STATUS:ERROR.
            
            IF dynClass = ? THEN 
            DO:
                body = entity:ReadJSON(filter).
            END.
            ELSE 
            DO:
                dynClass:Read(filter, OUTPUT DATASET-HANDLE hDataSet).
                jsonObject = NEW JsonObject().
                jsonObject:READ(hDataSet).
                body = jsonObject:GetJsonText().
            END.
        END.
        ELSE IF accessType = "catalog" THEN 
            DO:
                body = entity:Catalog().
            END.

//MESSAGE "DEBUG: " STRING(body).
        
        response = new WebResponse().        
        writer = new WebResponseWriter(response).
        
        IF response:StatusCode EQ 200 THEN 
        DO:
            response:ContentType = "application/json".
            MESSAGE "Before Write Response".            
            writer:write(body).
        END.

        MESSAGE "Before Flush".
        writer:flush().
        writer:close().            
    END METHOD.
    
    METHOD OVERRIDE PROTECTED INTEGER HandleNotAllowedMethod( INPUT poRequest AS OpenEdge.Web.IWebRequest ):
        
        UNDO, THROW NEW Progress.Lang.AppError("METHOD NOT IMPLEMENTED").
    END METHOD.

    METHOD OVERRIDE PROTECTED INTEGER HandleNotImplemented( INPUT poRequest AS OpenEdge.Web.IWebRequest ):
        
        UNDO, THROW NEW Progress.Lang.AppError("METHOD NOT IMPLEMENTED").
    END METHOD.    
    
END CLASS.